
#include "stdafx.h"
#include "OCXPlayDemo.h"
#include "OCXPlayDemoDlg.h"
#include "SwallowFunction.h"
#include "CLS_DlgCfgMain.h"

map<int, CONNECT_STATE> g_mapLogonInfo;

#define MAX_VALUME_NUM		65535		//ֵ

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "NetClientTypes.h"
#include <algorithm>

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


BEGIN_EVENTSINK_MAP(COCXPlayDemoDlg, CDialog)
	ON_EVENT(COCXPlayDemoDlg, IDC_SWALLOW, 1, COCXPlayDemoDlg::LogonMsgSwallow, VTS_I4 VTS_I4)
	ON_EVENT(COCXPlayDemoDlg, IDC_SWALLOW, 3, COCXPlayDemoDlg::OnObsClickedSwallow, VTS_UI4)
	ON_EVENT(COCXPlayDemoDlg, IDC_SWALLOW, 6, COCXPlayDemoDlg::StartPlaySwallow, VTS_I4 VTS_UI4)
	ON_EVENT(COCXPlayDemoDlg, IDC_SWALLOW, 16, COCXPlayDemoDlg::OnTalkSwallow, VTS_UI4 VTS_UI4)
	ON_EVENT(COCXPlayDemoDlg, IDC_SWALLOW, 28, COCXPlayDemoDlg::OnConnectDecryptSwallow, VTS_UI4 VTS_UI4 VTS_UI4)
END_EVENTSINK_MAP()


COCXPlayDemoDlg::COCXPlayDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COCXPlayDemoDlg::IDD, pParent)
{
	memset(m_lObsID, 0, sizeof(m_lObsID));
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_FileQueryDlg = new CFileQueryDlg(this);
	m_iEzoomEnable = FALSE;
	memset(&m_lconnectId, 0, sizeof(m_lconnectId));
	m_pSwallowOcxMain = NULL;
}

void COCXPlayDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//DDX_Control(pDX, IDC_SWALLOW, m_SwallowOcx);
	DDX_Control(pDX, IDC_COMBO_Frames, m_cboFrames);
	DDX_Control(pDX, IDC_IPADDRESS_IP, m_DeviceIPCtl);
	DDX_Control(pDX, IDC_IPADDRESS_PROXY, m_ProxyIPCtl);
	DDX_Control(pDX, IDC_COMBO_Channel, m_cboChannelCtl);
	DDX_Control(pDX, IDC_COMBO_Stream, m_cboStreamCtl);
	DDX_Control(pDX, IDC_COMBO_Mode, m_cboModeCtl);
	DDX_Control(pDX, IDC_EDIT_ID, m_edtIDCtl);
	DDX_Control(pDX, IDC_SLIDER_Volume, m_sldVolume);
	DDX_Control(pDX, IDC_BTN_EZOOM, m_edtEZoomEnable);
	DDX_Control(pDX, IDC_CHK_AUDIO_PREVIEW, m_chkAudio);
}

BEGIN_MESSAGE_MAP(COCXPlayDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO_Frames, &COCXPlayDemoDlg::OnCbnSelchangeComboFrames)
	ON_BN_CLICKED(IDC_BUTTON_Logon, &COCXPlayDemoDlg::OnBnClickedButtonLogon)
	ON_BN_CLICKED(IDC_BUTTON_Connect, &COCXPlayDemoDlg::OnBnClickedButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_PICTURE, &COCXPlayDemoDlg::OnBnClickedButtonPicture)
	ON_BN_CLICKED(IDC_BUTTON_Logoff, &COCXPlayDemoDlg::OnBnClickedButtonLogoff)
	ON_BN_CLICKED(IDC_BUTTON_Disconnect, &COCXPlayDemoDlg::OnBnClickedButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_Record, &COCXPlayDemoDlg::OnBnClickedButtonRecord)
	ON_BN_CLICKED(IDC_BTN_CONFIG, &COCXPlayDemoDlg::OnBnClickedBtnConfig)
	ON_BN_CLICKED(IDC_BUTTON_FileQuery, &COCXPlayDemoDlg::OnBnClickedButtonFilequery)
	ON_BN_CLICKED(IDC_BUTTON_OSD, &COCXPlayDemoDlg::OnBnClickedButtonOsd)
	ON_BN_CLICKED(IDC_BUTTON_DeviceTypeSet, &COCXPlayDemoDlg::OnBnClickedButtonDevicetypeset)
	ON_BN_CLICKED(IDC_BUTTON_HorAuto, &COCXPlayDemoDlg::OnBnClickedButtonHorauto)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTON_GotPreset, &COCXPlayDemoDlg::OnBnClickedButtonGotpreset)
	ON_BN_CLICKED(IDC_BUTTON_SetPreset, &COCXPlayDemoDlg::OnBnClickedButtonSetpreset)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_Brightness, &COCXPlayDemoDlg::OnNMCustomdrawSliderBrightness)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_Saturation, &COCXPlayDemoDlg::OnNMCustomdrawSliderSaturation)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_Contrast, &COCXPlayDemoDlg::OnNMCustomdrawSliderContrast)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_Hue, &COCXPlayDemoDlg::OnNMCustomdrawSliderHue)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_Speed, &COCXPlayDemoDlg::OnNMCustomdrawSliderSpeed)
	ON_BN_CLICKED(IDC_BUTTON_TALK, &COCXPlayDemoDlg::OnBnClickedButtonTalk)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_POWER, &COCXPlayDemoDlg::OnBnClickedCheckPower)
	ON_BN_CLICKED(IDC_CHECK_LIGHT, &COCXPlayDemoDlg::OnBnClickedCheckLight)
	ON_BN_CLICKED(IDC_CHECK_RAIN, &COCXPlayDemoDlg::OnBnClickedCheckRain)
	ON_BN_CLICKED(IDC_BUTTON_DECRYPT, &COCXPlayDemoDlg::OnBnClickedButtonDecrypt)
	ON_BN_CLICKED(IDC_BTN_EZOOM, &COCXPlayDemoDlg::OnBnClickedBtnEzoom)
	ON_BN_CLICKED(IDC_CHK_DECRYPT_TYPE, &COCXPlayDemoDlg::OnBnClickedChkDecryptType)
	ON_BN_CLICKED(IDC_CHK_VIDEO_SHOWMODE, &COCXPlayDemoDlg::OnBnClickedVideoShowMode)
	ON_BN_CLICKED(IDC_BTN_FULL_SCREEN, &COCXPlayDemoDlg::OnBnClickedBtnFullScreen)
	ON_BN_CLICKED(IDC_CHK_AUDIO_PREVIEW, &COCXPlayDemoDlg::OnBnClickedChkAudioPreview)
	ON_BN_CLICKED(IDC_BTN_SET_LOCAL_TIME, &COCXPlayDemoDlg::OnBnClickedBtnSetLocalTime)
END_MESSAGE_MAP()

BOOL COCXPlayDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	InitializeProductModelName();
	m_map_connectInfo.clear();

	RECT rcShow = {0};
	GetDlgItem(IDC_GBO_SWALLOW_MAIN)->GetWindowRect(&rcShow);
	ScreenToClient(&rcShow);
	m_pSwallowOcxMain = new CSwallow();
	int iRet = m_pSwallowOcxMain->Create(_T(""),_T(""), WS_CHILDWINDOW, rcShow, this, IDC_SWALLOW);
	m_pSwallowOcxMain->ShowWindow(SW_SHOW);
	m_pSwallowOcxMain->MoveWindow(&rcShow);

    InitDlg();						//ʼ	
	Swallow_Init(m_pSwallowOcxMain);	//ʼSwallow
	Swallow_SetWindowMode(m_pSwallowOcxMain, 4);
	OnCbnSelchangeComboFrames();
	return TRUE;
}

void COCXPlayDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void COCXPlayDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


HCURSOR COCXPlayDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//ʼ
void COCXPlayDemoDlg::InitDlg()
{
	CString szIP  = theApp.GetProfileString("LogonInfo", "IP", "");
	int     iPort = theApp.GetProfileInt("LogonInfo","PORT", 3000);
	m_DeviceIPCtl.SetWindowText(szIP);
    SetDlgItemInt(IDC_EDIT_PORT, iPort);

	m_cboChannelCtl.AddString(_T("CH1"));	//Ϊͨѡ	
	m_cboChannelCtl.SetCurSel(0);			//ͨѡĳʼֵ

	GetDlgItem(IDC_EDIT_USERNAME)->SetWindowText(_T("admin"));
	GetDlgItem(IDC_EDIT_PASSWORD)->SetWindowText(_T("admin"));

	//ʼModeѡ
	m_cboModeCtl.AddString(_T("TCP"));
	m_cboModeCtl.AddString(_T("UDP"));
	m_cboModeCtl.AddString(_T("MULTICAST"));
	m_cboModeCtl.SetCurSel(0);

	//ʼѡ
	m_cboStreamCtl.AddString(_T("Main"));
	m_cboStreamCtl.AddString(_T("Sub"));
	m_cboStreamCtl.AddString(_T("Third"));
	m_cboStreamCtl.SetCurSel(0);

	m_cboFrames.InsertString(0, _T("single"));
	m_cboFrames.InsertString(1, _T("four"));
	m_cboFrames.InsertString(2, _T("nine"));
	m_cboFrames.InsertString(3, _T("sixteen"));
	m_cboFrames.SetCurSel(0);

	//ʼƵSliderؼ
	CSliderCtrl *sldSaturation = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Saturation);
	sldSaturation->SetRange(0,255);
	sldSaturation = NULL;
	CSliderCtrl *sldBrightness = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Brightness);
	sldBrightness->SetRange(0,255);
	sldBrightness = NULL;
	CSliderCtrl *sldContrast = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Contrast);
	sldContrast->SetRange(0,255);
	sldContrast = NULL;
	CSliderCtrl *sldHue = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Hue);
	sldHue->SetRange(0,255);
	sldHue = NULL;

	//ʼַΪ
	CEdit *edtOSD = (CEdit *)GetDlgItem(IDC_EDIT_OSD);
	edtOSD->SetWindowText(_T(""));
	edtOSD = NULL;

	//ʼ豸ͶӦĸѡ
	CComboBox *cboDevType = (CComboBox *)GetDlgItem(IDC_COMBO_DeviceType);
	cboDevType->AddString(_T("PTZ_PELCO_D"));
	cboDevType->AddString(_T("PTZ_PELCO_P"));
	cboDevType->AddString(_T("PTZ_TC615_P"));
	cboDevType->AddString(_T("DOME_PELCO_D"));
	cboDevType->AddString(_T("DOME_PELCO_P"));
	cboDevType->AddString(_T("DOME_PLUS"));
	cboDevType->SetCurSel(-1);
	cboDevType = NULL;

	//ʼWorkModeӦѡ
	CComboBox *cboWorkMode = (CComboBox *)GetDlgItem(IDC_COMBO_WorkMode);
	cboWorkMode->AddString(_T("protocol"));
	cboWorkMode->AddString(_T("transparence channel"));
	cboWorkMode->SetCurSel(-1);
	cboWorkMode = NULL;

	//ʼںŶӦѡ
	CComboBox *cboComPort = (CComboBox *)GetDlgItem(IDC_COMBO_ComPort);
	cboComPort->AddString(_T("COM1"));
	cboComPort->AddString(_T("COM2"));
	cboComPort->SetCurSel(-1);
	cboComPort = NULL;

	//ʼٶȶӦSliderؼ
	CSliderCtrl *sldSpeed = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Speed);
	sldSpeed->SetRange(0,100);
	sldSpeed->SetPos(50);
	sldSpeed = NULL;

	m_sldVolume.SetRange(0,100);
}

void COCXPlayDemoDlg::AppendMsg(CString& _strMsg)
{
	CEdit* pEdit = (CEdit*)GetDlgItem(IDC_ALARM_MESSAGE);
	int iLen = pEdit->GetWindowTextLength();
	pEdit->SetSel(iLen,iLen,true);
	pEdit->ReplaceSel(_strMsg);
}

void COCXPlayDemoDlg::SetOSD(int _iFrame)
{
	map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(_iFrame);
	if (it != m_map_connectInfo.end())
	{
		CString szOSD;
		GetDlgItem(IDC_EDIT_OSD)->GetWindowText(szOSD);
		if (0 != SetOsdText(it->second.m_iLogonID, it->second.m_iChannelNO, szOSD, 0))
		{
			AppendMsg(CString("set osd failed"));
		}
	}
}

void COCXPlayDemoDlg::UpdateDeviceInfo(int _iObsId)
{
	int iChannelNO = 0;
	int iStreamNO = 0;
	int iNetMode = 1;
	CONNECT_STATE *pConnState = NULL;
	GetControlDeviceInfo(_iObsId);
	GetVideopara(_iObsId);
	if(-1 == _iObsId)
	{
		SetDlgItemText(IDC_BUTTON_Audio,_T("AudioStart"));
		GetDlgItem(IDC_BUTTON_TALK)->SetWindowText(_T("TalkStart"));
		GetDlgItem(IDC_EDIT_OSD)->SetWindowText(_T(""));
		GetDlgItem(IDC_BUTTON_Record)->SetWindowText(_T("Record"));
		m_chkAudio.SetCheck(BST_UNCHECKED);
		m_sldVolume.SetPos(0);
	}
	else
	{
		map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(_iObsId);
		if (it != m_map_connectInfo.end())
		{
			pConnState = &(it->second);
		}
		else
			return;
		SetDlgItemText(IDC_EDIT_PRODUCT_NAME, pConnState->m_strProductID);
		SetDlgItemText(IDC_EDIT_ID, pConnState->m_strID);
		SetDlgItemText(IDC_IPADDRESS_IP, pConnState->m_strIP);
		SetDlgItemText(IDC_IPADDRESS_PROXY, pConnState->m_strProxyIP);
		SetDlgItemInt(IDC_EDIT_PORT, pConnState->m_iPort);
		SetDlgItemText(IDC_EDIT_USERNAME, pConnState->m_strUser);
		SetDlgItemText(IDC_EDIT_PASSWORD, pConnState->m_strPwd);
		m_conCurrent = *pConnState;
		iChannelNO = m_conCurrent.m_iChannelNO;
		iStreamNO  = m_conCurrent.m_iStreamNO;
		iNetMode   = m_conCurrent.m_iNetMode;

		GetDlgItem(IDC_EDIT_OSD)->SetWindowText(GetOsdText(pConnState->m_iLogonID, pConnState->m_iChannelNO));

		bool blAudio = pConnState->m_blAudio;
		bool blRecord = pConnState->m_blRecord;

		if (blAudio)
		{
			SetDlgItemText(IDC_BUTTON_Audio,_T("AudioStop"));
			m_chkAudio.SetCheck(BST_CHECKED);
			int iValue = Swallow_VolumeGet(m_pSwallowOcxMain, _iObsId);
			if (iValue > 0)
			{
				iValue = (double)iValue / MAX_VALUME_NUM * 100;
				m_sldVolume.SetPos(iValue);
			}
		}
		else
		{
			SetDlgItemText(IDC_BUTTON_Audio,_T("AudioStart"));
			m_chkAudio.SetCheck(BST_UNCHECKED);
			m_sldVolume.SetPos(0);
		}

		if (pConnState->m_ulTalkState == 0)
		{
			GetDlgItem(IDC_BUTTON_TALK)->SetWindowText(_T("TalkStop"));
		}
		else
		{
			GetDlgItem(IDC_BUTTON_TALK)->SetWindowText(_T("TalkStart"));
		}

        if (blRecord)
        {
			GetDlgItem(IDC_BUTTON_Record)->SetWindowText(_T("Stop"));
        }
		else
		{
			GetDlgItem(IDC_BUTTON_Record)->SetWindowText(_T("Record"));
		}

	}

	m_cboChannelCtl.ResetContent();
	CString strChannel;
	for (int i = 1;i <= m_conCurrent.m_iTotalChannel;i++ )
	{
		strChannel.Format(_T("CH%d"),i);
		m_cboChannelCtl.AddString(strChannel);
	}

	m_cboChannelCtl.SetCurSel(iChannelNO);
	m_cboStreamCtl.SetCurSel(iStreamNO);
	CComboBox* pNetMode = (CComboBox*)GetDlgItem(IDC_COMBO_Mode);
	pNetMode->SetCurSel(iNetMode-1);
}

void COCXPlayDemoDlg::SetControlDeviceInfo(int _iFrame)//޸豸Ϣ
{
	map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(_iFrame);
	if (it != m_map_connectInfo.end())
	{
		CComboBox *cboComPort = (CComboBox *)GetDlgItem(IDC_COMBO_ComPort);
		CComboBox *cboWorkMode = (CComboBox *)GetDlgItem(IDC_COMBO_WorkMode);
		int iComPort = cboComPort->GetCurSel()+1;
		int iWorkMode = cboWorkMode->GetCurSel()+1;
		char cComFormat[32];
		memset(cComFormat,0,32);

		CString szDevType;
		CString szAddress;
		GetDlgItem(IDC_COMBO_DeviceType)->GetWindowText(szDevType);
		int iAddr = GetDlgItemInt(IDC_EDIT_Address);

		CONNECT_STATE *pConnState = &(it->second);
		VARIANT var = getitovar(0);
		VARIANT var1 = getitovar(pConnState->m_iLogonID);
		VARIANT var2 = getitovar(pConnState->m_iChannelNO);
		VARIANT var3 = getitovar(iComPort);
		VARIANT var4 = getstovar(szDevType);
		VARIANT varAdd = getitovar(iAddr);
		CString szRet = m_pSwallowOcxMain->Commander(Dev_Type_Set, var1, var2, var3, var4, varAdd, var, var, var, var);
		CStringArray szResult;
		szResult.SetSize(256);
		if (CheckRetValue(szRet, szResult) != 0)
		{
			AppendMsg(CString("Dev_Type_Set failed\n"));
		}

		CString strComFormat;
		GetDlgItem(IDC_EDIT_ComFormat)->GetWindowText(strComFormat);
		VARIANT var5 = getstovar(strComFormat);
		VARIANT var6 = getitovar(iWorkMode);
		szRet = m_pSwallowOcxMain->Commander(Dev_SetComFormat_Set, var1, var3, var4, var5, var6, var, var, var, var);
		if (CheckRetValue(szRet, szResult) != 0)
		{
			AppendMsg(CString("Dev_SetComFormat_Set failed\n"));
		}
	}
}

void COCXPlayDemoDlg::GetControlDeviceInfo(int _iFrame)
{
	if(_iFrame < 0)//豸Ϣ
	{
		GetDlgItem(IDC_EDIT_Address)->SetWindowText(_T(""));
		GetDlgItem(IDC_EDIT_ComFormat)->SetWindowText(_T(""));
		((CComboBox *)GetDlgItem(IDC_COMBO_ComPort))->SetCurSel(-1);
		((CComboBox *)GetDlgItem(IDC_COMBO_DeviceType))->SetCurSel(-1);
		((CComboBox *)GetDlgItem(IDC_COMBO_WorkMode))->SetCurSel(-1);
		return;
	}
	map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(_iFrame);
	if (it != m_map_connectInfo.end())
	{
		int iComPort = 0;
		int iDevAdd = 0;
		CString szDevType;
		CString szComFormat;
		int iWorkMode = 0;	
		CString strMstg;

		CONNECT_STATE *pConnState = &(it->second);
		VARIANT var = getitovar(0);
		VARIANT var1 = getitovar(pConnState->m_iLogonID);
		VARIANT var2 = getitovar(pConnState->m_iChannelNO);
		VARIANT var3 = getitovar(1);
		CString szRet = m_pSwallowOcxMain->Commander(Dev_Type_Get, var1, var2, var3, var, var, var, var, var, var);
		CStringArray szResult;
		szResult.SetSize(256);
		if (CheckRetValue(szRet, szResult) == 0)
		{
			CStringArray szInfo;
			szInfo.SetSize(256);
			SplitStringToArray(szResult[1], "\b", szInfo);
			iComPort = _ttoi(szInfo[0]);
			if (iComPort < 1)//ںŴ1ʼ
			{
				iComPort = 1;
			}	
			szDevType = szInfo[1];
            szComFormat = szInfo[2];
			iDevAdd     = _ttoi(szInfo[3]);
			GetDlgItem(IDC_EDIT_ComFormat)->SetWindowText(CString(szComFormat));
			CString strDevAdd;
			strDevAdd.Format(_T("%d"),iDevAdd);
			GetDlgItem(IDC_EDIT_Address)->SetWindowText(strDevAdd);
			SetDlgItemText(IDC_COMBO_DeviceType,szDevType);
			((CComboBox *)GetDlgItem(IDC_COMBO_ComPort))->SetCurSel(iComPort-1);
			if (iWorkMode < 1)//ڹʽ1Э顡2͸ͨ
			{
				iWorkMode = 1;
			}
			((CComboBox *)GetDlgItem(IDC_COMBO_WorkMode))->SetCurSel(iWorkMode-1); 
		}

		szRet = m_pSwallowOcxMain->Commander(Dev_SetComFormat_Get, var1, getitovar(iComPort), var, var, var, var, var, var, var);
		if (CheckRetValue(szRet, szResult) == 0)
		{
			CStringArray szInfo;
			szInfo.SetSize(256);
			SplitStringToArray(szResult[1], "\b", szInfo);
			iWorkMode = _ttoi(szInfo[1]);
			((CComboBox *)GetDlgItem(IDC_COMBO_WorkMode))->SetCurSel(iWorkMode-1); 
		}

	}
}

void COCXPlayDemoDlg::GetVideopara(int _iFrame)
{
	CSliderCtrl *sldSaturation = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Saturation);
	CSliderCtrl *sldBrightness = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Brightness);
	CSliderCtrl *sldContrast = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Contrast);
	CSliderCtrl *sldHue = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Hue);

	if (-1 == _iFrame)
	{
		sldSaturation->SetPos(0);
		SetDlgItemInt(IDC_STATIC_Saturation,0);
		sldBrightness->SetPos(0);
		SetDlgItemInt(IDC_STATIC_Brightness,0);
		sldContrast->SetPos(0);
		SetDlgItemInt(IDC_STATIC_Contrast,0);
		sldHue->SetPos(0);
		SetDlgItemInt(IDC_STATIC_Hue,0);
		return;
	}

	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(m_conCurrent.m_iLogonID);
	VARIANT var2 = getitovar(m_conCurrent.m_iChannelNO);

	CString szRet = m_pSwallowOcxMain->Commander(Video_Display_Get, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) == 0)
	{
		CStringArray szInfo;
		szInfo.SetSize(256);
		SplitStringToArray(szResult[1], "\b", szInfo);
		long u16Brightness = _ttol(szInfo[0]);
		long u16Contrast = _ttol(szInfo[1]);
		long u16Saturation = _ttol(szInfo[2]);
		long u16Hue = _ttol(szInfo[3]);
		sldSaturation->SetPos(u16Saturation);
		SetDlgItemInt(IDC_STATIC_Saturation,u16Saturation);
		sldBrightness->SetPos(u16Brightness);
		SetDlgItemInt(IDC_STATIC_Brightness,u16Brightness);
		sldContrast->SetPos(u16Contrast);
		SetDlgItemInt(IDC_STATIC_Contrast,u16Contrast);
		sldHue->SetPos(u16Hue);
		SetDlgItemInt(IDC_STATIC_Hue,u16Hue);
	}
	else//ȡʧܣøֵΪ0
	{
		sldSaturation->SetPos(0);
		SetDlgItemInt(IDC_STATIC_Saturation,0);
		sldBrightness->SetPos(0);
		SetDlgItemInt(IDC_STATIC_Brightness,0);
		sldContrast->SetPos(0);
		SetDlgItemInt(IDC_STATIC_Contrast,0);
		sldHue->SetPos(0);
		SetDlgItemInt(IDC_STATIC_Hue,0);
	}	
	sldBrightness = NULL;
	sldContrast = NULL;
	sldHue = NULL;
	sldSaturation = NULL;
}

//л໭
void COCXPlayDemoDlg::OnCbnSelchangeComboFrames()
{
	int iSel = ((CComboBox*)GetDlgItem(IDC_COMBO_Frames))->GetCurSel();

	VARIANT var  = getitovar(0);
	VARIANT var1 = getstovar("");
	VARIANT var2 = getitovar(iSel+1);
	VARIANT var3 = getitovar(iSel+1);

	CString szRet = m_pSwallowOcxMain->Commander(Obs_Monopolize_Cmd,var1,var2,var3,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		OutputDebugString("[OCXPlayDemoDlg]error in Obs_Monopolize_Cmd");
	}
}


int COCXPlayDemoDlg::CatchPic(long _lobsId, CString _szFileName, long _lPicQuality)
{
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var2 = getstovar(_szFileName);
	VARIANT var3 = getitovar(_lPicQuality);

	CString szRet = m_pSwallowOcxMain->Commander(Obs_Capture_Cmd,var1,var2,var3,var,var,var,var,var,var);    
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int  COCXPlayDemoDlg::StartRecord(long _lobsId, CString _szFileName, long _lPakTime, long _lPackSize)
{
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var2 = getstovar(_szFileName);
	VARIANT var3 = getitovar(_lPakTime);
	VARIANT var4 = getitovar(_lPackSize);
	CString szRet = m_pSwallowOcxMain->Commander(Obs_BeginRec_Cmd, var1, var2, var3, var4, var, var, var, var, var);    
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int  COCXPlayDemoDlg::StopRecord(long _lobsId)
{
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	CString szRet = m_pSwallowOcxMain->Commander(Obs_EndRec_Cmd, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int  COCXPlayDemoDlg::EnableAudio(long _lobsId, int _iEnable)
{
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var2 = getitovar(_iEnable);
	VARIANT var3 = getitovar(50000);
	CString szRet = m_pSwallowOcxMain->Commander(Obs_SpeakerEnable_Set, var1, var2, var3, var, var, var, var, var, var);   
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int COCXPlayDemoDlg::SetVolume(long _lVolumeSize)
{
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lVolumeSize);
    CString szRet = m_pSwallowOcxMain->Commander(Entry_Volume_Set, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

void COCXPlayDemoDlg::OnBnClickedButtonLogon()
{
	m_conCurrent.m_iLogonID = INVALID_CONNECT_ID;//½ID
	m_conCurrent.m_ulConID = INVALID_CONNECT_ID;
	GetDlgItemText(IDC_IPADDRESS_IP,m_conCurrent.m_strIP);
	GetDlgItemText(IDC_EDIT_USERNAME,m_conCurrent.m_strUser);
	GetDlgItemText(IDC_EDIT_PASSWORD,m_conCurrent.m_strPwd);
	GetDlgItemText(IDC_IPADDRESS_PROXY, m_conCurrent.m_strProxyIP);	
	if (m_conCurrent.m_strProxyIP.Compare(_T("0.0.0.0")) == 0)
	{
		m_conCurrent.m_strProxyIP = _T("");
	}
	m_conCurrent.m_iPort = GetDlgItemInt(IDC_EDIT_PORT);
	if (m_conCurrent.m_iPort <= 0)
	{
		m_conCurrent.m_iPort = 3000;
		SetDlgItemInt(IDC_EDIT_PORT, m_conCurrent.m_iPort);
	}
    int _lLogonID = Swallow_Logon(m_pSwallowOcxMain, m_conCurrent.m_strProxyIP, m_conCurrent.m_strIP, m_conCurrent.m_strUser, m_conCurrent.m_strPwd, "", m_conCurrent.m_iPort);
	if (_lLogonID >= 0)
	{
		m_conCurrent.m_iLogonID = _lLogonID;
		GetDeviceProp(&m_conCurrent);
		m_edtIDCtl.SetWindowText(m_conCurrent.m_strID);
		int iMode = 0;
		Swallow_GetDevModel(m_pSwallowOcxMain, m_conCurrent.m_iLogonID, &iMode, m_conCurrent.m_strProductID);
		SetDlgItemText(IDC_EDIT_PRODUCT_NAME, m_conCurrent.m_strProductID);

		int iIndex = m_cboChannelCtl.GetCurSel();
		m_cboChannelCtl.ResetContent();
		CString strChannel;
		for (int i = 1;i <= m_conCurrent.m_iTotalChannel;i++ )
		{
			strChannel.Format(_T("CH%d"),i);
			m_cboChannelCtl.AddString(strChannel);
		}
		m_cboChannelCtl.SetCurSel(iIndex);
		//szMsg.Format("logon success, logon id is: %d\n",_lLogonID);
		//AppendMsg(szMsg);
		//UpdateDeviceInfo(-1);
		m_FileQueryDlg->m_iLogonID = m_conCurrent.m_iLogonID;

		map<int, CONNECT_STATE>::iterator	it = g_mapLogonInfo.find(_lLogonID);
		if (g_mapLogonInfo.end() == it)
		{
			g_mapLogonInfo.insert(pair<int, CONNECT_STATE>(_lLogonID, m_conCurrent));
		}		
	}
	theApp.WriteProfileInt("LogonInfo","PORT", m_conCurrent.m_iPort);
	theApp.WriteProfileString("LogonInfo", "IP", m_conCurrent.m_strIP);
}

void COCXPlayDemoDlg::GetDeviceProp(CONNECT_STATE *pConnState)
{
    if (pConnState->m_iLogonID == INVALID_LOGON_ID)
    {
		return;
    }
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(pConnState->m_iLogonID);
	CString szRet = m_pSwallowOcxMain->Commander(Entry_Prop_Get,var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		szRet.Format("[OCXPlayDemoDlg]function failed at %s, line:%d , errno is %d\n",__FILE__, __LINE__, GetLastError());
		OutputDebugString(szRet);
	}
	else
	{
		CStringArray szInfo;
		szInfo.SetSize(256);
		SplitStringToArray(szResult[1],"\b",szInfo);
		if (_ttoi(szInfo[0]) == INVALID_LOGON_ID)
		{
			return;
		}
		long lLogonStatus = _ttol(szInfo[0]);
		pConnState->m_strProxyIP  = szInfo[1];
		pConnState->m_strIP = szInfo[2];
		pConnState->m_strID = szInfo[3];
		pConnState->m_iPort = _ttoi(szInfo[4]);
		pConnState->m_iTotalChannel = _ttol(szInfo[5]);
		pConnState->m_strUser = szInfo[6];
		pConnState->m_strPwd  = szInfo[7];
		long lAuth = _ttol(szInfo[8]);
	}

}

void COCXPlayDemoDlg::LogonMsgSwallow(long lLogStatus, long _lLogonID)
{
	//swallow ״ֵ̬ЭֵΪ1
	CString szMsg;
	switch (lLogStatus)
	{
		case 6:
		case 1://½ɹʾ豸ID
		{
			OutputDebugString(_T("success/n"));
			if (lLogStatus == 6)
			{
				ObsShowMessage(m_pSwallowOcxMain->GetCurObs(), true, "Already logon on", 3000);				
			}
			else
			{
				ObsShowMessage(m_pSwallowOcxMain->GetCurObs(), true, "Logon success", 3000);
			}			
			m_conCurrent.m_iLogonID = _lLogonID;
			GetDeviceProp(&m_conCurrent);
			m_edtIDCtl.SetWindowText(m_conCurrent.m_strID);
			int iMode = 0;
			Swallow_GetDevModel(m_pSwallowOcxMain, m_conCurrent.m_iLogonID, &iMode, m_conCurrent.m_strProductID);
			SetDlgItemText(IDC_EDIT_PRODUCT_NAME, m_conCurrent.m_strProductID);

			int iIndex = m_cboChannelCtl.GetCurSel();
			m_cboChannelCtl.ResetContent();
			CString strChannel;
			for (int i = 1;i <= m_conCurrent.m_iTotalChannel;i++ )
			{
				strChannel.Format(_T("CH%d"),i);
				m_cboChannelCtl.AddString(strChannel);
			}
			m_cboChannelCtl.SetCurSel(iIndex);
			szMsg.Format("logon success, logon id is: %d\n",_lLogonID);
			AppendMsg(szMsg);
			//UpdateDeviceInfo(-1);
			m_FileQueryDlg->m_iLogonID = m_conCurrent.m_iLogonID;

			map<int, CONNECT_STATE>::iterator	it = g_mapLogonInfo.find(_lLogonID);
			if (g_mapLogonInfo.end() == it)
			{
				g_mapLogonInfo.insert(pair<int, CONNECT_STATE>(_lLogonID, m_conCurrent));
			}			
			break;
		}
		case 2:
		{
			ObsShowMessage(m_pSwallowOcxMain->GetCurObs(), true, "Logon failed", 3000);
			break;
		}
		case 3:
		{
			ObsShowMessage(m_pSwallowOcxMain->GetCurObs(), true, "Logon failed", 3000);
			break;
		}
		case 4:
		{
			ObsShowMessage(m_pSwallowOcxMain->GetCurObs(), true, "Logon failed", 3000);
			break;
		}
		case 5:
		{
			ObsShowMessage(m_pSwallowOcxMain->GetCurObs(), true, "Logon failed", 3000);
			break;
		}	

	}
	if (lLogStatus != 1 && lLogStatus != 6)
	{
		if (m_conCurrent.m_iLogonID == _lLogonID)
		{
			//m_conCurrent.m_iLogonID = INVALID_LOGON_ID;
			m_edtIDCtl.SetWindowText(_T(""));	
			SetDlgItemText(IDC_EDIT_PRODUCT_NAME, _T(""));
		}
		szMsg.Format("logon failed, last error is: %d\n",GetLastError());
		AppendMsg(szMsg);
		
	}
}

void COCXPlayDemoDlg::OnBnClickedButtonConnect()
{
	if (m_conCurrent.m_iLogonID == INVALID_LOGON_ID)
	{
		return;
	}
	m_conCurrent.m_iChannelNO = m_cboChannelCtl.GetCurSel();
	m_conCurrent.m_iStreamNO = m_cboStreamCtl.GetCurSel();
	m_conCurrent.m_iNetMode = m_cboModeCtl.GetCurSel()+1;
	long lobsID=m_pSwallowOcxMain->GetCurObs();

	CLIENTINFO stParam = {0};
	stParam.m_iServerID		= m_conCurrent.m_iLogonID;	//¼Id
	stParam.m_iChannelNo	= m_conCurrent.m_iChannelNO;//ͨ
	stParam.m_iStreamNO		= m_conCurrent.m_iStreamNO;	//
	stParam.m_iBufferCount	= 10;						//С
	stParam.m_iDelayNum		= 1;						//֡	
	stParam.m_iNetMode		= m_conCurrent.m_iNetMode;	//ģʽ,Ĭ1 TCP
	if(0 > Swallow_ConnectVideo(m_pSwallowOcxMain, lobsID, stParam))
	{
		CString szRet;
		szRet.Format("[OCXPlayDemoDlg]function failed at %s, line:%d , errno is %d\n",__FILE__, __LINE__, GetLastError());
		OutputDebugString(szRet);
		return;
	}

	CONNECT_STATE connectState;
	map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(lobsID);
	if (it == m_map_connectInfo.end())
	{
		m_map_connectInfo.insert(pair<long, CONNECT_STATE>(lobsID, connectState));
		it = m_map_connectInfo.find(lobsID);
	}
	it->second = m_conCurrent;

	UpdateDeviceInfo(lobsID);
}

void COCXPlayDemoDlg::OnBnClickedButtonPicture()
{
	CString szFileName;
	SYSTEMTIME systime = {0};
	GetLocalTime(&systime);
	szFileName.Format("%04d%02d%02d%02d%02d%02d%s", systime.wYear, systime.wMonth, systime.wDay, systime.wHour, systime.wMinute, systime.wSecond, ".bmp" );
	long lobsID  = m_pSwallowOcxMain->GetCurObs();

	if (0 != CatchPic(lobsID, szFileName, 50))
	{
		CString szRet;
		szRet.Format("[OCXPlayDemoDlg]function failed at %s, line:%d , errno is %d\n",__FILE__, __LINE__, GetLastError());
		OutputDebugString(szRet);
	}
}

void COCXPlayDemoDlg::OnObsClickedSwallow(unsigned long _ulObsID)
{
	long lobsID=m_pSwallowOcxMain->GetCurObs();
	map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(lobsID);
	if (it != m_map_connectInfo.end())
	{
		if (it->second.m_iLogonID != INVALID_LOGON_ID)
		{
			UpdateDeviceInfo(lobsID);
		}	
	}
	else
	{
		UpdateDeviceInfo(-1);
	}
}

void COCXPlayDemoDlg::OnBnClickedButtonLogoff()
{
	int iLogonID = m_conCurrent.m_iLogonID;
	if (iLogonID == INVALID_LOGON_ID)//ǰûе½в
	{
		return;
	}

	if (0 != Swallow_LogonOff(m_pSwallowOcxMain, iLogonID))
	{
		CString szRet;
		szRet.Format("[OCXPlayDemoDlg]function failed at %s, line:%d , errno is %d\n",__FILE__, __LINE__, GetLastError());
		AfxMessageBox(szRet);
	}
	else
	{
		m_conCurrent.m_iLogonID = INVALID_LOGON_ID;
		m_conCurrent.m_ulConID  = INVALID_CONNECT_ID;	
		UpdateDeviceInfo(-1);//µǰ״̬Ϣ
		
		map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.begin();
		for(it; it != m_map_connectInfo.end(); it++)
		{
			if(it->second.m_iLogonID == iLogonID)
			{
				it->second.m_iLogonID = INVALID_LOGON_ID;
				it->second.m_ulConID = INVALID_CONNECT_ID;	
				it->second.m_ulTalkState = -1;
				it->second.m_blRecord = false;
				it->second.m_blAudio = false;
			}
		}
		long lobsid = m_pSwallowOcxMain->GetCurObs();
		for (int i = 0; i < CONST_iFrameNum; i++)
		{
			if (lobsid == m_lconnectId[i])
			{
				m_blAudio[i] = false;
				m_blRecord[i] = false;
			}
		}
		SetDlgItemText(IDC_EDIT_ID,_T(""));
		SetDlgItemText(IDC_EDIT_PRODUCT_NAME,_T(""));
		SetDlgItemText(IDC_BUTTON_Audio,_T("AudioStart"));
	}
}

void COCXPlayDemoDlg::OnBnClickedButtonDisconnect()
{
	long lobsID  = m_pSwallowOcxMain->GetCurObs();
	if (0 == Swallow_DisConnectVideo(m_pSwallowOcxMain, lobsID))
	{
		map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(lobsID);
		if (it != m_map_connectInfo.end())
		{
			it->second.m_ulConID  = INVALID_CONNECT_ID;
			it->second.m_iLogonID = INVALID_LOGON_ID;
			it->second.m_ulTalkState = -1;
			it->second.m_blRecord = false;
			it->second.m_blAudio = false;
		}
		//long lobsid = m_pSwallowOcxMain->GetCurObs();
		//for (int i = 0; i < CONST_iFrameNum; i++)
		//{
		//	if (lobsid == m_lconnectId[i])
		//	{
		//		m_blAudio[i] = false;
		//		m_blRecord[i] = false;
		//	}
		//}
	}
	else
	{
		CString szRet;
		szRet.Format("[OCXPlayDemoDlg]function failed at %s, line:%d , errno is %d\n",__FILE__, __LINE__, GetLastError());
		AppendMsg(szRet);
	}
}

void COCXPlayDemoDlg::OnBnClickedButtonRecord()
{
    //todo ޸¼
	CString strCaption;
	GetDlgItem(IDC_BUTTON_Record)->GetWindowText(strCaption);

	long lobsID  = m_pSwallowOcxMain->GetCurObs();
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(lobsID);

	if (strCaption == "Record")//û¼񣬿ʼ¼
	{
		CString szFileName;
		SYSTEMTIME systime = {0};
		GetLocalTime(&systime);
		szFileName.Format("%04d%02d%02d%02d%02d%02d%s", systime.wYear, systime.wMonth, systime.wDay, systime.wHour, systime.wMinute, systime.wSecond, ".sdv"); 
		//szFileName.Format("123.sdv");  
		if (0 == StartRecord(lobsID, szFileName, 60, 1000))
		{
			GetDlgItem(IDC_BUTTON_Record)->SetWindowText(_T("Stop"));

			long lobsID=m_pSwallowOcxMain->GetCurObs();
			map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(lobsID);
			if (it != m_map_connectInfo.end())
			{
				it->second.m_blRecord = true;
			}
			//for (int i = 0; i < CONST_iFrameNum; i++)
			//{
			//	if (m_lconnectId[i] == lobsID)
			//	{
			//		m_blRecord[i] = true;
			//	}
			//}
		}
	}
	else//¼ֹͣ
	{
		if (0 == StopRecord(lobsID))
		{
			GetDlgItem(IDC_BUTTON_Record)->SetWindowText(_T("Record"));
			long lobsID=m_pSwallowOcxMain->GetCurObs();
			map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(lobsID);
			if (it != m_map_connectInfo.end())
			{
				it->second.m_blRecord = false;
			}
			//for (int i = 0; i < CONST_iFrameNum; i++)
			//{
			//	if (m_lconnectId[i] == lobsID)
			//	{
			//		m_blRecord[i] = false;
			//	}
			//}
		}
	}
}

void COCXPlayDemoDlg::OnBnClickedBtnConfig()
{
	//ʾҳ
	CLS_DlgCfgMain clsCfg;
	clsCfg.DoModal();
	return;

	long lobsID  = m_pSwallowOcxMain->GetCurObs();
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(lobsID);
	CString szRet = m_pSwallowOcxMain->Commander(Entry_Config_Get, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		OutputDebugString("Video_Display_Set failed");
	}
}

void COCXPlayDemoDlg::OnBnClickedButtonFilequery()
{
	m_FileQueryDlg->m_iLogonID = m_conCurrent.m_iLogonID;
	if(m_FileQueryDlg->m_iLogonID < 0)
	{
		OutputDebugString(_T("[CDemoDlg::OnBnClickedBtnFileQuery] Invalid LogonID!\n"));
	//	return;
	}
    m_FileQueryDlg->m_iTotalChannel = m_conCurrent.m_iTotalChannel;
	m_FileQueryDlg->m_cstrNvsIP = m_conCurrent.m_strIP;
	if (m_FileQueryDlg->GetSafeHwnd() == NULL)
	{
		m_FileQueryDlg->Create(IDD_DIALOG_FILEQUERY, this);
		m_FileQueryDlg->CenterWindow(this);
	}
	else
		m_FileQueryDlg->SetWindowPos(&wndTopMost, NULL, NULL, NULL, NULL, SWP_NOSIZE|SWP_NOMOVE);
}

void COCXPlayDemoDlg::OnBnClickedChkAudioPreview()
{
	long lobsID  = m_pSwallowOcxMain->GetCurObs();
	int iConnectStatus = Swallow_ConnectStatus(m_pSwallowOcxMain, lobsID);
	if (iConnectStatus <= 0)
	{
		//ǰObsδƵƵ
		((CButton*)GetDlgItem(IDC_CHK_AUDIO_PREVIEW))->SetCheck(FALSE);
		return;
	}
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(lobsID);
	VARIANT var3 = getitovar(50000);
	CStringArray szResult;
	szResult.SetSize(256);
	BOOL blAudioStart = ((CButton*)GetDlgItem(IDC_CHK_AUDIO_PREVIEW))->GetCheck();
	if (blAudioStart)
	{
		VARIANT var2 = getitovar(1);
		CString szRet = m_pSwallowOcxMain->Commander(Obs_SpeakerEnable_Set, var1, var2, var3, var, var, var, var, var, var);   
		if (CheckRetValue(szRet, szResult) != 0)
		{
			OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkAudioPreview]Audio Start Failed!"));
		}

		int iValue = Swallow_VolumeGet(m_pSwallowOcxMain, m_pSwallowOcxMain->GetCurObs());
		if (iValue < 0)
		{
			OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkAudioPreview] VolumeGet Failed!"));
			return;
		}

		//ƵʱֵΪ0Ϊ20
		int iPos = 20;
		if (0 == iValue)
		{
			USHORT usiValume = (double)iPos / 100 * MAX_VALUME_NUM;
		}

		int iRet = Swallow_VolumeSet(m_pSwallowOcxMain, m_pSwallowOcxMain->GetCurObs(), iValue);
		if (iRet < 0)
		{
			OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkAudioPreview] VolumeSet Failed!"));
			return;
		}

		iValue = (double)iValue / MAX_VALUME_NUM * 100;

		map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(lobsID);
		if (it != m_map_connectInfo.end())
		{
			it->second.m_blAudio = true;
		}
		m_sldVolume.SetPos(iValue);
	}
	else
	{
		VARIANT var2 = getitovar(0);
		CString szRet = m_pSwallowOcxMain->Commander(Obs_SpeakerEnable_Set, var1, var2, var3, var, var, var, var, var, var);   
		if (CheckRetValue(szRet, szResult) != 0)
		{
			OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkAudioPreview]Audio Stop Failed!"));
		}

		map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(lobsID);
		if (it != m_map_connectInfo.end())
		{
			it->second.m_blAudio = false;
		}
		m_sldVolume.SetPos(0);
	}
}

void COCXPlayDemoDlg::OnBnClickedButtonOsd()
{
	SetOSD( m_pSwallowOcxMain->GetCurObs());
}

void COCXPlayDemoDlg::OnBnClickedButtonDevicetypeset()
{
	SetControlDeviceInfo(m_pSwallowOcxMain->GetCurObs());
}

void COCXPlayDemoDlg::OnBnClickedButtonHorauto()
{
	CString strCaption;
	int iRet;
	GetDlgItem(IDC_BUTTON_HorAuto)->GetWindowText(strCaption);
	if (strCaption == "Auto")//ΪAuto״̬
	{
		iRet = DevControl(HOR_AUTO);//úDevControlHOR_AUTO
		if (iRet == 0)
		{
			GetDlgItem(IDC_BUTTON_HorAuto)->SetWindowText(_T("Stop"));
		}		
	}
	else//ΪStop״̬
	{
		iRet = DevControl(HOR_AUTO_STOP);//úDevControlHOR_AUTO STOP
		if (iRet == 0)
		{
			GetDlgItem(IDC_BUTTON_HorAuto)->SetWindowText(_T("Auto"));
		}		
	}
}

int COCXPlayDemoDlg::GetActionNoAndPara(int _iMove, int _iSpeed, int _iPreset, int &_iAction, int &_iPara1, int &_iPara2)
{
	switch(_iMove)//ҪתΪЭ
	{
	case MOVE_UP://ƶ
		_iAction = 1;
		_iPara1 = 0;
		_iPara2 = _iSpeed;
		break;
	case MOVE_DOWN://ƶ
		_iAction = 2;
		_iPara1 = 0;
		_iPara2 = _iSpeed;
		break;
	case MOVE_LEFT://ƶ
		_iAction = 3;
		_iPara1 = _iSpeed;
		_iPara2 = 0;
		break;
	case MOVE_RIGHT://ƶ
		_iAction = 4;
		_iPara1 = _iSpeed;
		_iPara2 = 0;
		break;
	case MOVE_UP_LEFT://ƶ
		_iAction = 6;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case MOVE_UP_RIGHT://ƶ
		_iAction = 5;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case MOVE_DOWN_LEFT://ƶ
		_iAction = 8;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case MOVE_DOWN_RIGHT://ƶ
		_iAction = 7;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;	
	case ZOOM_BIG://䱶
		_iAction = 10;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case ZOOM_SMALL://䱶С
		_iAction = 11;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case FOCUS_NEAR://۽
		_iAction = 13;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case FOCUS_FAR://۽Զ
		_iAction = 14;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case IRIS_OPEN://Ȧ
		_iAction = 17;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case IRIS_CLOSE://Ȧ
		_iAction = 18;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case RAIN_ON://rain on
		_iAction = 19;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case RAIN_OFF: //rain off
		_iAction = 20;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case LIGHT_ON://light on
		_iAction = 21;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case LIGHT_OFF://light off
		_iAction = 22;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case HOR_AUTO://horizontal auto
		_iAction = 23;
		_iPara1 = 0;
		_iPara2 = 0;
		break;
	case HOR_AUTO_STOP://stop horizontal auto
		_iAction = 24;
		_iPara1 = 0;
		_iPara2 = 0;
		break;
	case CALL_VIEW://Ԥλ
		_iAction = 25;
		_iPara1 = _iPreset;
		_iPara2 = 0;
		break;
	case SET_VIEW://Ԥλ
		_iAction = 28;
		_iPara1 = _iPreset;
		_iPara2 = 0;
		break;
	case POWER_ON://power on
		_iAction = 29;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	case POWER_OFF://power off
		_iAction = 30;
		_iPara1 = _iSpeed;
		_iPara2 = _iSpeed;
		break;
	default:
		_iAction = 9;
		_iPara1 = 0;
		_iPara2 = 0;
		break;
	}
	return 0;
}

int COCXPlayDemoDlg::DevControl(int _iMove)
{
	CSliderCtrl *sldSpeed =(CSliderCtrl *)GetDlgItem(IDC_SLIDER_Speed);
	CComboBox *cboWorkMode = (CComboBox *)GetDlgItem(IDC_COMBO_WorkMode);
	int iSpeed = sldSpeed->GetPos();
	int iWorkMode = cboWorkMode->GetCurSel();
	CString strPreset;
	GetDlgItem(IDC_EDIT_Preset)->GetWindowText(strPreset);
	int iPreset;
	if (strPreset == "")
	{
		iPreset = 0;
	}
	else
	{
		iPreset = atoi(CT2CA(strPreset));
		if (iPreset < 1 || iPreset > 255)
		{
			OutputDebugString(_T("Setting preset position is incorrect!"));
			GetDlgItem(IDC_EDIT_Preset)->SetWindowText(_T(""));
		}
	}
	CString strAddress;
	GetDlgItem(IDC_EDIT_Address)->GetWindowText(strAddress);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(m_conCurrent.m_iLogonID);
	VARIANT var2 = getitovar(m_conCurrent.m_iChannelNO);
	VARIANT var3 = getitovar(_ttoi(strAddress));//豸ַ
	VARIANT var4 = getitovar(_iMove);
	VARIANT var5 = getitovar(iSpeed);
	VARIANT var6 = getitovar(iPreset);
	int iComPort;
	CComboBox *cboComPort =(CComboBox *)GetDlgItem(IDC_COMBO_ComPort);
	iComPort = cboComPort->GetCurSel()+1;
	VARIANT var7 = getitovar(iComPort);
	CString szDevType;
	GetDlgItem(IDC_COMBO_DeviceType)->GetWindowText(szDevType);
	VARIANT var8 = getstovar(szDevType);
	if (iWorkMode == 0)
	{
		CButton *chkPTZ = (CButton *)GetDlgItem(IDC_CHECK_ePTZ);
		int iChecked = chkPTZ->GetCheck();	
		int iAction = 0;
		int iPara1 = 0;
		int iPara2 = 0;
		GetActionNoAndPara(_iMove, iSpeed, iPreset, iAction, iPara1, iPara2);
		CString szRet = m_pSwallowOcxMain->Commander(Dev_Device_Ctrl, var1, var2, getitovar(iAction), getitovar(iPara1), getitovar(iPara2), getitovar(iChecked), var, var, var);
		CStringArray szResult;
		szResult.SetSize(256);
		if (CheckRetValue(szRet, szResult) != 0)
		{
			return -1;
		}
		
	}
	else
	{
		CString szRet = m_pSwallowOcxMain->Commander(Dev_Control_Cmd, var1, var2, var3, var4, var5, var6, var7, var8, var);
		CStringArray szResult;
		szResult.SetSize(256);
		if (CheckRetValue(szRet, szResult) != 0)
		{
			return -1;
		}
	}
	return 0;
}

void COCXPlayDemoDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	CDialog::OnLButtonDown(nFlags, point);
	switch(nFlags)
	{
	case IDC_BUTTON_MOVE_UP://ƶ
		DevControl(MOVE_UP);
		break;
	case IDC_BUTTON_MOVE_DOWN://ƶ
		DevControl(MOVE_DOWN);
		break;
	case IDC_BUTTON_MOVE_LEFT://ƶ
		DevControl(MOVE_LEFT);
		break;
	case IDC_BUTTON_MOVE_RIGHT://ƶ
		DevControl(MOVE_RIGHT);			
		break;
	case IDC_BUTTON_MOVE_UP_LEFT://ƶ
		DevControl(MOVE_UP_LEFT);
		break;
	case IDC_BUTTON_MOVE_UP_RIGHT://ƶ
		DevControl(MOVE_UP_RIGHT);
		break;
	case IDC_BUTTON_MOVE_DOWN_LEFT://ƶ
		DevControl(MOVE_DOWN_LEFT);
		break;
	case IDC_BUTTON_MOVE_DOWN_RIGHT://ƶ
		DevControl(MOVE_DOWN_RIGHT);
		break;
	case IDC_BUTTON_FOCUS_NEAR://۽
		DevControl(FOCUS_NEAR);
		break;
	case IDC_BUTTON_FOCUS_FAR://۽Զ
		DevControl(FOCUS_FAR);
		break;
	case IDC_BUTTON_ZOOM_BIG://䱶
		DevControl(ZOOM_BIG);
		break;
	case IDC_BUTTON_ZOOM_SMALL://䱶С
		DevControl(ZOOM_SMALL);
		break;
	case IDC_BUTTON_IRIS_OPEN://Ȧ
		DevControl(IRIS_OPEN);
		break;
	case IDC_BUTTON_IRIS_CLOSE://Ȧ
		DevControl(IRIS_CLOSE);
		break;
	default :
		break;
	}
}

void COCXPlayDemoDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	CDialog::OnLButtonUp(nFlags, point);
	switch(nFlags)
	{
	case IDC_BUTTON_MOVE_UP://ֹͣƶ
		DevControl(MOVE_UP_STOP);
		break;
	case IDC_BUTTON_MOVE_DOWN://ֹͣƶ
		DevControl(MOVE_DOWN_STOP);
		break;
	case IDC_BUTTON_MOVE_LEFT://ֹͣƶ
		DevControl(MOVE_LEFT_STOP);
		break;
	case IDC_BUTTON_MOVE_RIGHT://ֹͣƶ
		DevControl(MOVE_RIGHT_STOP);
		break;
	case IDC_BUTTON_MOVE_UP_LEFT://ֹͣƶ
		DevControl(MOVE_UP_LEFT_STOP);
		break;
	case IDC_BUTTON_MOVE_UP_RIGHT://ֹͣƶ
		DevControl(MOVE_UP_RIGHT_STOP);
		break;
	case IDC_BUTTON_MOVE_DOWN_LEFT://ֹͣƶ
		DevControl(MOVE_DOWN_LEFT_STOP);
		break;
	case IDC_BUTTON_MOVE_DOWN_RIGHT://ֹͣƶ
		DevControl(MOVE_DOWN_RIGHT_STOP);
		break;
	case IDC_BUTTON_FOCUS_NEAR://ֹͣ۽
		DevControl(FOCUS_NEAR_STOP);
		break;
	case IDC_BUTTON_FOCUS_FAR://ֹͣ۽Զ
		DevControl(FOCUS_FAR_STOP);
		break;
	case IDC_BUTTON_ZOOM_BIG://ֹͣ䱶
		DevControl(ZOOM_BIG_STOP);
		break;
	case IDC_BUTTON_ZOOM_SMALL://ֹͣ䱶С
		DevControl(ZOOM_SMALL_STOP);
		break;
	case IDC_BUTTON_IRIS_OPEN://ֹͣȦ
		DevControl(IRIS_OPEN_STOP);
		break;
	case IDC_BUTTON_IRIS_CLOSE://ֹͣȦز
		DevControl(IRIS_CLOSE_STOP);
		break;
	default :
		break;
	}	
}

void COCXPlayDemoDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int iCtrlID = pScrollBar->GetDlgCtrlID();
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(m_conCurrent.m_iLogonID);
	VARIANT var2 = getitovar(m_conCurrent.m_iChannelNO);
	
	if (SB_ENDSCROLL != nSBCode)
	{
		return;
	}

	switch (iCtrlID)
	{
	case IDC_SLIDER_Brightness:
	case IDC_SLIDER_Contrast:
	case IDC_SLIDER_Saturation:
	case IDC_SLIDER_Hue:
		{
			CSliderCtrl *psldBrightness = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Brightness);
			CSliderCtrl *psldContrast = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Contrast);	
			CSliderCtrl *psldSaturation = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Saturation);	
			CSliderCtrl *psldHue = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Hue);

			STR_VideoParam strVideoParam = {0};
			strVideoParam.m_u16Saturation = psldSaturation->GetPos();
			strVideoParam.m_u16Brightness = psldBrightness->GetPos();
			strVideoParam.m_u16Contrast = psldContrast->GetPos();
			strVideoParam.m_u16Hue = psldHue->GetPos();


			VARIANT var3 = getitovar(strVideoParam.m_u16Brightness);
			VARIANT var4 = getitovar(strVideoParam.m_u16Contrast);
			VARIANT var5 = getitovar(strVideoParam.m_u16Saturation);
			VARIANT var6 = getitovar(strVideoParam.m_u16Hue);
			CString szRet = m_pSwallowOcxMain->Commander(Video_Display_Set, var1, var2, var3, var4, var5, var6, var, var, var);
			CStringArray szResult;
			szResult.SetSize(256);
			if (CheckRetValue(szRet, szResult) == 0)
			{

			}
			else
			{
				OutputDebugString("Video_Display_Set failed");
			}	
		}
		break;
	case IDC_SLIDER_Volume:
		{
			int iPos = 0;
			iPos = m_sldVolume.GetPos();

			USHORT usiValume = (double)iPos / 100 * MAX_VALUME_NUM;
			int iRet = Swallow_VolumeSet(m_pSwallowOcxMain, m_pSwallowOcxMain->GetCurObs(), usiValume);
			if (iRet < 0)
			{
				OutputDebugString("[COCXPlayDemoDlg::OnHScroll] VolumeSet Failed!");
			}

			iRet = Swallow_VolumeGet(m_pSwallowOcxMain, m_pSwallowOcxMain->GetCurObs());

			if (iRet < 0)
			{
				OutputDebugString("[COCXPlayDemoDlg::OnHScroll] VolumeGet Failed!");
				return;
			}

			if (0 == iPos)
			{
				((CButton*)GetDlgItem(IDC_CHK_AUDIO_PREVIEW))->SetCheck(FALSE);
				m_sldVolume.SetPos(0);
			}
			else
			{
				((CButton*)GetDlgItem(IDC_CHK_AUDIO_PREVIEW))->SetCheck(TRUE);
				iPos = (double)iRet / MAX_VALUME_NUM * 100;
				m_sldVolume.SetPos(iPos);
			}
		}
		break;
	default:
		break;
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

}

BOOL COCXPlayDemoDlg::PreTranslateMessage(MSG* pMsg)
{
	if( pMsg->message == WM_LBUTTONUP)//WM_LBUTTONUPϢת
	{
		switch(::GetDlgCtrlID(pMsg->hwnd))
		{
		case IDC_BUTTON_MOVE_UP://ƶĿưť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_MOVE_UP);
			break;
		case IDC_BUTTON_MOVE_DOWN://ƶĿưť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_MOVE_DOWN);
			break;
		case IDC_BUTTON_MOVE_LEFT://ƶĿưť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_MOVE_LEFT);
			break;
		case IDC_BUTTON_MOVE_RIGHT://ƶĿưť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_MOVE_RIGHT);
			break;
		case IDC_BUTTON_MOVE_UP_LEFT://ƶĿưť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_MOVE_UP_LEFT);
			break;
		case IDC_BUTTON_MOVE_UP_RIGHT://ƶĿưť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_MOVE_UP_RIGHT);
			break;
		case IDC_BUTTON_MOVE_DOWN_LEFT://ƶĿưť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_MOVE_DOWN_LEFT);
			break;
		case IDC_BUTTON_MOVE_DOWN_RIGHT://ƶĿưť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_MOVE_DOWN_RIGHT);
			break;
		case IDC_BUTTON_FOCUS_NEAR://۽İť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_FOCUS_NEAR);
			break;
		case IDC_BUTTON_FOCUS_FAR://۽Զİť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_FOCUS_FAR);
			break;
		case IDC_BUTTON_ZOOM_BIG://䱶İť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_ZOOM_BIG);
			break;
		case IDC_BUTTON_ZOOM_SMALL://䱶Сİť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_ZOOM_SMALL);
			break;
		case IDC_BUTTON_IRIS_OPEN://򿪹Ȧİť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_IRIS_OPEN);
			break;
		case IDC_BUTTON_IRIS_CLOSE://رչȦİť
			SendMessage(WM_LBUTTONUP,IDC_BUTTON_IRIS_CLOSE);
			break;
		default :
			break;
		}
	}
	if( pMsg->message == WM_LBUTTONDOWN)//WM_LBUTTONDOWNϢת
	{
		switch(::GetDlgCtrlID(pMsg->hwnd))
		{
		case IDC_BUTTON_MOVE_UP://ɿƶĿưť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_MOVE_UP);
			break;
		case IDC_BUTTON_MOVE_DOWN://ɿƶĿưť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_MOVE_DOWN);
			break;
		case IDC_BUTTON_MOVE_LEFT://ɿƶĿưť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_MOVE_LEFT);
			break;
		case IDC_BUTTON_MOVE_RIGHT://ɿƶĿưť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_MOVE_RIGHT);
			break;
		case IDC_BUTTON_MOVE_UP_LEFT://ɿƶĿưť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_MOVE_UP_LEFT);
			break;
		case IDC_BUTTON_MOVE_UP_RIGHT://ɿƶĿưť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_MOVE_UP_RIGHT);
			break;
		case IDC_BUTTON_MOVE_DOWN_LEFT://ɿƶĿưť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_MOVE_DOWN_LEFT);
			break;
		case IDC_BUTTON_MOVE_DOWN_RIGHT://ɿƶĿưť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_MOVE_DOWN_RIGHT);
			break;
		case IDC_BUTTON_FOCUS_NEAR://ɿ۽İť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_FOCUS_NEAR);
			break;
		case IDC_BUTTON_FOCUS_FAR://ɿ۽Զİť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_FOCUS_FAR);
			break;
		case IDC_BUTTON_ZOOM_BIG://ɿ䱶İť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_ZOOM_BIG);
			break;
		case IDC_BUTTON_ZOOM_SMALL://ɿ䱶Сİť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_ZOOM_SMALL);
			break;
		case IDC_BUTTON_IRIS_OPEN://ɿȦİť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_IRIS_OPEN);
			break;
		case IDC_BUTTON_IRIS_CLOSE://ɿȦصİť
			SendMessage(WM_LBUTTONDOWN,IDC_BUTTON_IRIS_CLOSE);
			break;
		default :
			break;
		}
	}
	if (pMsg->message == WM_KEYDOWN || pMsg->message == WM_KEYUP)
	{
		if (pMsg->wParam == VK_ESCAPE)
		{
			return true;
		}
	}
	if(pMsg->message == WM_LBUTTONDBLCLK)
	{ 
		CEdit* pEdit = (CEdit*)GetDlgItem(IDC_ALARM_MESSAGE);
		if(pMsg->hwnd == pEdit->GetSafeHwnd()) 
		{
			pEdit->SetWindowText(_T(""));
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void COCXPlayDemoDlg::OnBnClickedButtonGotpreset()
{
	CString strPreset;
	GetDlgItem(IDC_EDIT_Preset)->GetWindowText(strPreset);
	if (strPreset == "")
	{
		OutputDebugString(_T("Setting preset position is incorrect!"));
		return;
	}
	DevControl(CALL_VIEW);//úDevControlеԤλ
}

void COCXPlayDemoDlg::OnBnClickedButtonSetpreset()
{
	CString strPreset;
	GetDlgItem(IDC_EDIT_Preset)->GetWindowText(strPreset);
	if (strPreset == "")
	{
		OutputDebugString(_T("Setting preset position is incorrect!"));
		return;
	}
	DevControl(SET_VIEW);//úDevControlԤλ
}

void COCXPlayDemoDlg::OnNMCustomdrawSliderBrightness(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	CSliderCtrl *sldBrightness = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Brightness);
	char cBrightness[16];
	sprintf_s(cBrightness,16,"%d",sldBrightness->GetPos());
	GetDlgItem(IDC_STATIC_Brightness)->SetWindowText(CA2CT(cBrightness));
	sldBrightness = NULL;

	*pResult = 0;
}

void COCXPlayDemoDlg::OnNMCustomdrawSliderSaturation(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	CSliderCtrl *sldSaturation = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Saturation);
	char cSaturation[16];
	sprintf_s(cSaturation,16,"%d",sldSaturation->GetPos());
	GetDlgItem(IDC_STATIC_Saturation)->SetWindowText(CA2CT(cSaturation));
	sldSaturation = NULL;

	*pResult = 0;
}

void COCXPlayDemoDlg::OnNMCustomdrawSliderContrast(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	CSliderCtrl *sldContrast = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Contrast);
	char cContrast[16];
	sprintf_s(cContrast,16,"%d",sldContrast->GetPos());
	GetDlgItem(IDC_STATIC_Contrast)->SetWindowText(CA2CT(cContrast));
	sldContrast = NULL;

	*pResult = 0;
}

void COCXPlayDemoDlg::OnNMCustomdrawSliderHue(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	CSliderCtrl *sldHue = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Hue);
	char cHue[16];
	sprintf_s(cHue,16,"%d",sldHue->GetPos());
	GetDlgItem(IDC_STATIC_Hue)->SetWindowText(CA2CT(cHue));	
	sldHue = NULL;

	*pResult = 0;
}

void COCXPlayDemoDlg::OnNMCustomdrawSliderSpeed(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	CSliderCtrl *sldSpeed = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_Speed);
	char cSpeed[16];
	sprintf_s(cSpeed,16,"%d",sldSpeed->GetPos());
	GetDlgItem(IDC_STATIC_Speed)->SetWindowText(CA2CT(cSpeed));	
	sldSpeed = NULL;

	*pResult = 0;
}


void COCXPlayDemoDlg::StartPlaySwallow(long _lResult, unsigned long _ulConnID)
{
	long lobsid = _ulConnID;
	if (_lResult < 0)
	{
		CString szMsg;
		szMsg.Format("start play error,errno is %d", GetLastError());
		OutputDebugString(szMsg);
		return;
	}
	else
	{
		bool blAudio = false;
		for (int i = 0; i < CONST_iFrameNum; i++)
		{
			if (m_lconnectId[i] == lobsid)
			{
				blAudio = m_blAudio[i];
			}
		}
		if (blAudio)
		{
			for (int i = 0; i < CONST_iFrameNum; i++)
			{
				if (m_blAudio[i] && m_lconnectId[i] != lobsid)
				{
					EnableAudio(m_lconnectId[i], 0);
					m_blAudio[i] = false;
				}
			}
			
			EnableAudio(lobsid, 1);
		}

		int i;
		for (i = 0; i < CONST_iFrameNum; i++)
		{
			if (m_lconnectId[i] == lobsid)
			{
				break;
			}
		}
		if (m_blRecord[i])
		{
			CString szFileName;
			SYSTEMTIME systime = {0};
			GetLocalTime(&systime);
			szFileName.Format("%04d%02d%02d%02d%02d%02d%s", systime.wYear, systime.wMonth, systime.wDay, systime.wHour, systime.wMinute, (systime.wSecond + i)%60, ".sdv" );  
			if (0 == StartRecord(m_lconnectId[i], szFileName, 60, 1000))
			{

			}
		}	
	}
}

int COCXPlayDemoDlg::EnableTalk(int _iLogonId, int _iEnbale)
{
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iLogonId);
	VARIANT var2 = getitovar(_iEnbale);
	CString szRet = m_pSwallowOcxMain->Commander(Obs_MicEnable_Set,var1,var2,var,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) == 0)
	{
		return 0;
	}
	return -1;
}

CString COCXPlayDemoDlg::GetOsdText(int _iLogonId, int _iChannelNo)
{
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iLogonId);
	VARIANT var2 = getitovar(_iChannelNo);
	CString szRet = m_pSwallowOcxMain->Commander(Osd_Text_Get, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) == 0)
	{
		CStringArray szInfo;
		szInfo.SetSize(256);
		SplitStringToArray(szResult[1], "\b", szInfo);
		return szInfo[0];
	}
	return "";
}

int COCXPlayDemoDlg::SetOsdText(int _iLogonId, int _iChannelNo, CString _szOsdText, int _iTextColor)
{
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iLogonId);
	VARIANT var2 = getitovar(_iChannelNo);
	VARIANT var3 = getstovar(_szOsdText);
	VARIANT var4 = getitovar(_iTextColor);
	CString szRet = m_pSwallowOcxMain->Commander(Osd_Text_Set,var1,var2,var3,var4,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int COCXPlayDemoDlg::ObsShowMessage(long _lobsId, bool _blShow, CString _szMessage, int _iMs)
{
	int iShow = _blShow?1:0; 
	VARIANT var2;
	VariantInit(&var2);
	var2.vt = VT_UINT;
	var2.boolVal = _blShow;
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var3 = getstovar(_szMessage);
	VARIANT var4 = getitovar(_iMs);
	CString szRet = m_pSwallowOcxMain->Commander(Obs_ShowMsg_Cmd,var1,var2,var3,var4,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int COCXPlayDemoDlg::DecryptVideo(long _lLogonId, int _iChannelNo, CString _szKey, int _iKeyLen)
{
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_lLogonId);
	VARIANT var2 = getitovar(_iChannelNo);
	VARIANT var3 = getstovar(_szKey);
	VARIANT var4 = getitovar(_iKeyLen);
	CString szRet = m_pSwallowOcxMain->Commander(DEVICE_DECRYPT_SET,var1,var2,var3,var4,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

void COCXPlayDemoDlg::OnBnClickedButtonTalk()
{
	CString szCaption;
	GetDlgItem(IDC_BUTTON_TALK)->GetWindowText(szCaption);
	map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.find(m_pSwallowOcxMain->GetCurObs());
	if (szCaption == "TalkStart")
	{
		if (it != m_map_connectInfo.end())
		{
			if(0 == EnableTalk(it->second.m_iLogonID, 1))
			{
				GetDlgItem(IDC_BUTTON_TALK)->SetWindowText(_T("TalkStop"));
			}
		}
	}
	else
	{
		if (it != m_map_connectInfo.end())
		{
			if(0 == EnableTalk(it->second.m_iLogonID, 0))
			{
				GetDlgItem(IDC_BUTTON_TALK)->SetWindowText(_T("TalkStart"));
				it->second.m_ulTalkState = -1;
			}
		}
	}
}



void COCXPlayDemoDlg::OnTalkSwallow(unsigned long _LogonID, unsigned long _State)
{
	map<long, CONNECT_STATE>::iterator it = m_map_connectInfo.begin();
	for (it; it != m_map_connectInfo.end(); it++)
	{
		if (it->second.m_iLogonID == _LogonID)
		{
			it->second.m_ulTalkState = _State;
			break;
		}
	}
	if (m_conCurrent.m_iLogonID == _LogonID)
	{
		if ( 0 == _State)
		{
			GetDlgItem(IDC_BUTTON_TALK)->SetWindowText(_T("TalkStop"));
		}
		else
		{
			GetDlgItem(IDC_BUTTON_TALK)->SetWindowText(_T("TalkStart"));
		}
	}
}

void COCXPlayDemoDlg::OnDestroy()
{
	CDialog::OnDestroy();
	m_map_connectInfo.clear();
}

void COCXPlayDemoDlg::OnBnClickedCheckPower()
{
	CButton *btnPower = (CButton *)GetDlgItem(IDC_CHECK_POWER);
	if (btnPower->GetCheck())
	{
		if(0 != DevControl(POWER_ON))//úDevControlPOWER ON
		{
			btnPower->SetCheck(BST_UNCHECKED);
			AppendMsg(CString("DevControl(POWER_ON) failed......\n"));
		}
	}
	else
	{
		if (0 != DevControl(POWER_OFF))//úDevControlPOWER OFF
		{
			AppendMsg(CString("DevControl(POWER_OFF) failed......\n"));
		}		
	}
	btnPower = NULL;
}

void COCXPlayDemoDlg::OnBnClickedCheckLight()
{
	CButton *btnPower = (CButton *)GetDlgItem(IDC_CHECK_LIGHT);
	if (btnPower->GetCheck())//ѡ״̬
	{
		if(0 != DevControl(LIGHT_ON))//úDevControlLIGHT ON
		{
			btnPower->SetCheck(BST_UNCHECKED);
			AppendMsg(CString("DevControl(LIGHT_ON) failed......\n"));
		}
	}
	else//ѡ״̬
	{
		if (0 != DevControl(LIGHT_OFF))//úDevControlLIGHT OFF
		{
			AppendMsg(CString("DevControl(LIGHT_OFF) failed......\n"));
		}
	}
	btnPower = NULL;
}

void COCXPlayDemoDlg::OnBnClickedCheckRain()
{
	CButton *btnPower = (CButton *)GetDlgItem(IDC_CHECK_RAIN);
	if (btnPower->GetCheck())//ѡ״̬
	{
		if(0 != DevControl(RAIN_ON))//úDevControlRAIN ON
		{
			btnPower->SetCheck(BST_UNCHECKED);
			AppendMsg(CString("DevControl(RAIN_ON) failed......\n"));
		}
	}
	else//ѡ״̬
	{
		if (0 != DevControl(RAIN_OFF))//úDevControlLIGHT OFF
		{
			AppendMsg(CString("DevControl(RAIN_OFF) failed......\n"));
		}
	}
	btnPower = NULL;
}

void COCXPlayDemoDlg::OnBnClickedButtonDecrypt()
{
    if (m_conCurrent.m_iLogonID == INVALID_LOGON_ID)
    {
		return;
    }
	CString szKey;
	GetDlgItem(IDC_EDIT_DECRYPT)->GetWindowText(szKey);
	if (0 != DecryptVideo(m_conCurrent.m_iLogonID, m_conCurrent.m_iChannelNO, szKey, szKey.GetLength()))
	{
		AppendMsg(CString("Decrypt failed......\n"));
	}
}

void COCXPlayDemoDlg::OnConnectDecryptSwallow(unsigned long _lLogonID, unsigned long _ulChannel, unsigned long _lNotifyType)
{
	CString szMsg;
	szMsg.Format("_lLogon id:%d, channel:%d, type:%d\n", _lLogonID, _ulChannel, _lNotifyType);
	OutputDebugString(szMsg);
	if (WCM_NEED_DECRYPT_KEY == _lNotifyType || WCM_DECRYPT_KEY_FAILED == _lNotifyType)
	{
		AppendMsg(CString("need Decrypt key......\n"));
	}
	else if (WCM_DECRYPT_SUCCESS == _lNotifyType)
	{
		AppendMsg(CString("Decrypt success......\n"));
	}
	else
	{
		CString szMsg;
		szMsg.Format("_lLogon id:%d, channel:%d, type:%d", _lLogonID, _ulChannel, _lNotifyType);
		AppendMsg(CString("failed ,need Decrypt key......\n"));
	}
}

void COCXPlayDemoDlg::OnBnClickedBtnEzoom()
{
	long lobsID=m_pSwallowOcxMain->GetCurObs();
	m_iEzoomEnable = !m_iEzoomEnable;
	if (m_iEzoomEnable)
	{
		m_edtEZoomEnable.SetWindowText("EZoom Off");
	}
	else
	{
		m_edtEZoomEnable.SetWindowText("EZoom On");
	}

	int iRet = Swallow_SetEZoomEnable(m_pSwallowOcxMain, lobsID, m_iEzoomEnable);
	if (iRet < 0)
	{
		return;
	}
}


void COCXPlayDemoDlg::OnBnClickedChkDecryptType()
{
	int iValue = ((CButton*)GetDlgItem(IDC_CHK_DECRYPT_TYPE))->GetCheck() ? 0 : 1;
	int iRet = Swallow_DecryptTipEnable(m_pSwallowOcxMain, m_pSwallowOcxMain->GetCurObs(), iValue);
	if (iRet < 0)
	{
		OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkDecryptType] Set DecryptTipEnable Failed!"));
		((CButton*)GetDlgItem(IDC_CHK_DECRYPT_TYPE))->SetCheck((BOOL)iValue);
	}
}
// 1 - ̶ 0 - Ӧ
// ĬΪӦ 0
void COCXPlayDemoDlg::OnBnClickedVideoShowMode()
{
	int iValue = ((CButton*)GetDlgItem(IDC_CHK_VIDEO_SHOWMODE))->GetCheck() ? VIDEOSHOW_MODE_FIX_PROPORTION : VIDEOSHOW_MODE_FIT_WINDOW;
	int iRet = Swallow_SetVideoShowModel(m_pSwallowOcxMain, m_pSwallowOcxMain->GetCurObs(), iValue);
	if (iRet < 0)
	{
		OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkDecryptType] Set DecryptTipEnable Failed!"));
	}

	iRet = Swallow_GetVideoShowModel(m_pSwallowOcxMain, m_pSwallowOcxMain->GetCurObs());
	if (iRet < 0)
	{
		OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkDecryptType] Get DecryptTipEnable Failed!"));
	}
	
	if (VIDEOSHOW_MODE_FIX_PROPORTION == iRet)
	{
		SetDlgItemText(IDC_CHK_VIDEO_SHOWMODE, _T("FixProportion"));
		((CButton*)GetDlgItem(IDC_CHK_VIDEO_SHOWMODE))->SetCheck(TRUE);
	}
	else
	{
		SetDlgItemText(IDC_CHK_VIDEO_SHOWMODE, _T("FitWindow"));
		((CButton*)GetDlgItem(IDC_CHK_VIDEO_SHOWMODE))->SetCheck(FALSE);
	}
}

void COCXPlayDemoDlg::OnBnClickedBtnFullScreen()
{
	int iRet = Swallow_SysFullScreen(m_pSwallowOcxMain, TRUE);
	if (iRet < 0)
	{
		OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedBtnFullScreen] Set SysFullScreen Failed!"));
	}
}

void COCXPlayDemoDlg::OnBnClickedBtnSetLocalTime()
{
	// TODO: Add your control notification handler code here

	if (m_conCurrent.m_iLogonID == INVALID_LOGON_ID)
	{
		return;
	}

	int iRet = Swallow_SetLocalTime(m_pSwallowOcxMain, m_conCurrent.m_iLogonID);
	if (iRet < 0)
	{
		OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedBtnSetLocalTime] Set LocalTime Failed!"));
	}

}
