
#include "stdafx.h"
#include "SwallowFunction.h"

int Swallow_Init(CSwallow* _pSwallow, int _iPreClumNum/*=4*/, int _iPreRowNum/*=4*/, int _iPbkClumNum/*=2*/, int _iPbkRowNum/*=2*/)
{	
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var	 = getitovar(0);
	VARIANT var1 = getitovar(_iPreClumNum);	//ԤƵ
	VARIANT var2 = getitovar(_iPreRowNum);	//ԤƵ
	VARIANT var3 = getitovar(_iPbkClumNum);	//طƵ
	VARIANT var4 = getitovar(_iPbkRowNum);	//طƵ
	CString szRet = _pSwallow->Commander(Obs_Init_Cmd,var1,var2,var3,var4,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_Logon(CSwallow* _pSwallow, CString _szProxyIp, CString _szIp, CString _szUser, 
				  CString _szPwd, CString _szDeviceId, long _lPort)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getstovar(_szProxyIp);	//IP
	VARIANT var2 = getstovar(_szIp);		//豸IP
	VARIANT var3 = getstovar(_szUser);		//û
	VARIANT var4 = getstovar(_szPwd);		//
	VARIANT var5 = getstovar(_szDeviceId);	//豸Id
	VARIANT var6 = getitovar(_lPort);		//˿
	CString szRet = _pSwallow->Commander(Entry_Logon_Cmd,var1,var2,var3,var4,var5,var6,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return _ttoi(szResult[1]);
}

int Swallow_LogonOff(CSwallow* _pSwallow, long _lLongonId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_lLongonId);
	CString szRet = _pSwallow->Commander(Entry_Logoff_Cmd, var1, var, var, var, var, var, var, var, var);    
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_SetWindowMode(CSwallow* _pSwallow, int _iNum/*=0*/)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getstovar("");
	VARIANT var2 = getitovar(_iNum);
	VARIANT var3 = getitovar(_iNum);
	CString szRet = _pSwallow->Commander(Obs_Monopolize_Cmd,var1,var2,var3,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int Swallow_GetProgress(CSwallow* _pSwallow,  int _iObsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	CString szRet = _pSwallow->Commander(Obs_Progress_Get, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
 	CStringArray szInfo;
 	szInfo.SetSize(256);
 	SplitStringToArray(szRet, _T("\n"), szInfo);
 	int iCurrentPos = _ttoi(szInfo[1]);
 	return iCurrentPos;
}

int Swallow_Stop(CSwallow* _pSwallow, int _iObsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	CString szRet = _pSwallow->Commander(Obs_Stop_Cmd, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int Swallow_Slow(CSwallow* _pSwallow, int _iObsId, int _iValue)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	VARIANT var2 = getitovar(_iValue);

	CString szRet = _pSwallow->Commander(Obs_SlowForward_Cmd, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int Swallow_PlayPause( CSwallow* _pSwallow, int _iObsId, int _iPlayStatus )
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	VARIANT var2 = getitovar(_iPlayStatus);

	CString szRet = _pSwallow->Commander(Obs_PlayBackPause_Cmd, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;	
}


int Swallow_Fast(CSwallow* _pSwallow, int _iObsId, int _iValue)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	VARIANT var2 = getitovar(_iValue);

	CString szRet = _pSwallow->Commander(Obs_FastForward_Cmd, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int Swallow_Step(CSwallow* _pSwallow, int _iObsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);

	CString szRet = _pSwallow->Commander(Obs_StepForward_Cmd, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}


int Swallow_GetTotalTime(CSwallow* _pSwallow,  int _iObsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	CString szRet = _pSwallow->Commander(Obs_PlayBackTotalTime_Get, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	CStringArray szInfo;
	szInfo.SetSize(256);
	SplitStringToArray(szRet, _T("\n"), szInfo);
	int iTotalTime = _ttoi(szInfo[1]);
	return iTotalTime;
}


int Swallow_GetCurretTime(CSwallow* _pSwallow,  int _iObsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	CString szRet = _pSwallow->Commander(Obs_PlayBackCurTime_Get, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	CStringArray szInfo;
	szInfo.SetSize(256);
	SplitStringToArray(szRet, _T("\n"), szInfo);
	int iCurretTime = _ttoi(szInfo[1]);
	return iCurretTime;
}

int Swallow_Seek(CSwallow* _pSwallow, int _iObsId, int _iPos)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	VARIANT var2 = getitovar(_iPos);

	CString szRet = _pSwallow->Commander(Obs_Progress_Set, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int Swallow_CapturePic(CSwallow* _pSwallow, int _iObsId, CString _cstrFileName, int _iValue)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	VARIANT var2 = getstovar(_cstrFileName);
	VARIANT var3 = getitovar(_iValue);

	CString szRet = _pSwallow->Commander(Obs_Capture_Cmd, var1, var2, var3, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	CStringArray szInfo;
	szInfo.SetSize(256);
	SplitStringToArray(szRet, _T("\n"), szInfo);
	int iPicStorage = _ttoi(szInfo[1]);
	return iPicStorage;
}


int Swallow_StartRecord(CSwallow* _pSwallow, int _iObsId, CString _cstrFileName)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	VARIANT var2 = getstovar(_cstrFileName);

	CString szRet = _pSwallow->Commander(Obs_BeginRec_Cmd, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}


int Swallow_StopRecord(CSwallow* _pSwallow,  int _iObsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	CString szRet = _pSwallow->Commander(Obs_EndRec_Cmd, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		return -1;
	}
	return 0;
}

int Swallow_GetDevModel(CSwallow* _pSwallow, int _iLogonId, int* _iModel, CString &_cstrDevType)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_iLogonId);
	CStringArray szResult;
	szResult.SetSize(256);
	CString szRet = _pSwallow->Commander(Dev_Model_Get, var1, var, var, var, var, var, var, var, var);
	szResult.SetSize(256);
	SplitStringToArray(szRet,_T("\n"),szResult);
	if (szResult[0] == "0")
	{
		CStringArray szInfo;
		szInfo.SetSize(256);
		SplitStringToArray(szResult[1], _T("\b"), szInfo);
		WORD loValue = LOWORD(_ttoi(szInfo[0]));		//ȡ16λ
		WORD hiValue  = HIWORD(_ttoi(szInfo[1]));		//ȡ16λ
		*_iModel = loValue;
		_cstrDevType = GetProductModelName(loValue);
	}
	else
	{
		_cstrDevType = "Unknow Device";
	}
	return 0;
}

int Swallow_ConnectVideo(CSwallow* _pSwallow, long _lobsId, CLIENTINFO _stInfo)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);					//ƵId
	VARIANT var2 = getitovar(_stInfo.m_iServerID);		//¼Id
	VARIANT var3 = getitovar(_stInfo.m_iChannelNo);		//ͨ
	VARIANT var4 = getitovar(_stInfo.m_iStreamNO);		//
	VARIANT var5 = getitovar(_stInfo.m_iBufferCount);	//
	VARIANT var6 = getitovar(_stInfo.m_iDelayNum);		//Ƶ֡
	VARIANT var7 = getitovar(_stInfo.m_iNetMode);		//Ƶģʽ
	CString szRet = _pSwallow->Commander(Obs_StartRealTime_Cmd,var1,var2,var3,var4,var5,var6,var7,var,var);  //Ƶ
	CStringArray szResult;
	szResult.SetSize(256);
	SplitStringToArray(szRet,_T("\n"),szResult);
	int iResult = _ttoi(szResult[0]);
	if (iResult < 0)
	{
		return iResult;
	}
	return 0;
}

int Swallow_DisConnectVideo(CSwallow* _pSwallow, long _lobsid)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsid);
	CString szRet = _pSwallow->Commander(Obs_Stop_Cmd, var1, var, var, var, var, var, var, var, var);    
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_ConnectStatus(CSwallow* _pSwallow, long _lobsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);					//ƵId
	CString szRet = _pSwallow->Commander(Obs_PreviewStatus_Get,var1,var,var,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	SplitStringToArray(szRet,_T("\n"),szResult);
	int iResult = _ttoi(szResult[0]);
	if (iResult < 0)
	{
		return iResult;
	}

	int iState = _ttoi(szResult[1]);
	return iState;

}

int Swallow_StartDraw(CSwallow* _pSwallow, long _lobsId, int _iDrawType)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);					//ƵId
	VARIANT var2 = getitovar(_iDrawType);				//
	CString szRet = _pSwallow->Commander(Obs_StartDraw_Cmd,var1,var2,var,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_SetDrawColor(CSwallow* _pSwallow, long _lobsId, int _iColor)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);					//ƵId
	VARIANT var2 = getitovar(_iColor);					//ɫ
	CString szRet = _pSwallow->Commander(Obs_DrawColor_Cmd,var1,var2,var,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_StopDraw(CSwallow* _pSwallow, long _lobsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);					//ƵId
	CString szRet = _pSwallow->Commander(Obs_StopDraw_Cmd,var1,var,var,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
} 

int Swallow_ClearDraw(CSwallow* _pSwallow, long _lobsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);					//ƵId
	CString szRet = _pSwallow->Commander(Obs_ClearDraw_Cmd,var1,var,var,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
} 

int Swallow_GetDrawInfo(CSwallow* _pSwallow, long _lobsId, CString &_cstrDrawInfo)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);					//ƵId
	CString szRet = _pSwallow->Commander(Obs_GetDraw_Cmd,var1,var,var,var,var,var,var,var,var);

	char *pcSplit = _T("\n");
	int iArrayCount = 0;
	CString strTem;		//ַ

	//жϷֵ
	if (!AfxExtractSubString(strTem, szRet, iArrayCount++, pcSplit[0]))
	{
		return -1;
	}
	int iResult = _ttoi(strTem);
	if (iResult < 0)
	{
		return -1;
	}
	
	//ȡ
	if (!AfxExtractSubString(strTem, szRet, iArrayCount++, pcSplit[0]))
	{
		return -1;
	}
	CString cstrDraw;
	cstrDraw.Format("AreaNum:%s", strTem);

	int iAreaNum = _ttoi(strTem);
	for (int i=0; i<iAreaNum; i++)
	{
		//ȡ
		if (!AfxExtractSubString(strTem, szRet, iArrayCount++, pcSplit[0]))
		{
			return -1;
		}
		CString cstrArea;
		cstrArea.Format("Area%d PointNum:%s\n", i+1, strTem);
		cstrDraw += "\n";
		cstrDraw += cstrArea;

		int iPtNum = _ttoi(strTem);					//
		for (int j=0; j<iPtNum; j++)
		{
			if (!AfxExtractSubString(strTem, szRet, iArrayCount++, pcSplit[0]))
			{
				return -1;
			}
			//cstrDraw.Format("%sPoint%d:(%s), ", cstrDraw, j+1, strTem);
			CString cstrPoint;
			cstrPoint.Format("Point%d:(%s), ", j+1, strTem);
			cstrDraw += cstrPoint;
		}
	}
	_cstrDrawInfo = cstrDraw;
	return 0;
} 


int Swallow_SetDrawInfo(CSwallow* _pSwallow, long _lobsId, int _iInfo)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);					//ƵId
	VARIANT var2 = getitovar(_iInfo);
	CString szRet = _pSwallow->Commander(Obs_SetDraw_Cmd,var1,var2,var,var,var,var,var,var,var);

	char *pcSplit = _T("\n");
	CString strTem;		//ַ

	//жϷֵ
	if (!AfxExtractSubString(strTem, szRet, 0, pcSplit[0]))
	{
		return -1;
	}
	int iResult = _ttoi(strTem);
	if (iResult < 0)
	{
		return -1;
	}
	return 0;
}

int Swallow_VolumeSet(CSwallow* _pSwallow, long _lobsId, USHORT _iValue)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var2 = getitovar(_iValue);
	CString szRet = _pSwallow->Commander(Obs_Volume_Set, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_VolumeGet(CSwallow* _pSwallow, long _lobsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);				
	CString szRet = _pSwallow->Commander(Obs_Volume_Get,var1,var,var,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	SplitStringToArray(szRet,_T("\n"),szResult);
	int iResult = _ttoi(szResult[0]);
	if (iResult < 0)
	{
		return iResult;
	}

	int iValume = _ttoi(szResult[1]);
	return iValume;

}

int Swallow_PlayRemoteByTime(CSwallow* _pSwallow, long _lobsId, long _loLogonId, long _loPlayType, 
				long _loChannelNo, long _loStreamNo, CString _cstrBegainTime, CString _cstrEndTime )
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);				
	VARIANT var2 = getitovar(_loLogonId);				
	VARIANT var3 = getitovar(_loPlayType);				
	VARIANT var4 = getitovar(_loChannelNo);				
	VARIANT var5 = getitovar(_loStreamNo);				
	VARIANT var6 = getstovar(_cstrBegainTime);				
	VARIANT var7 = getstovar(_cstrEndTime);				
	CString szRet = _pSwallow->Commander(Obs_StartPlayBackByTime_Cmd, 
											var1, var2, var3, var4, var5, var6, var7, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_DecryptTipEnable(CSwallow* _pSwallow, long _lobsId, int _iValue)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var2 = getitovar(_iValue);
	CString szRet = _pSwallow->Commander(Obs_Enable_DecryptTip, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_SetVideoShowModel(CSwallow* _pSwallow, int _iObsId, int _iMode)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	VARIANT var2 = getitovar(_iMode);
	CString szRet = _pSwallow->Commander(Obs_VideoShowMode_Set, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_GetVideoShowModel(CSwallow* _pSwallow, int _iObsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_iObsId);
	CString szRet = _pSwallow->Commander(Obs_VideoShowMode_Get, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	SplitStringToArray(szRet,_T("\n"),szResult);
	int iResult = _ttoi(szResult[0]);
	if (iResult < 0)
	{
		return iResult;
	}

	int iState = _ttoi(szResult[1]);
	return iState;
}

int Swallow_SysFullScreen(CSwallow* _pSwallow, BOOL _blFlag)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_blFlag);
	CString szRet = _pSwallow->Commander(Sys_FullScreen_Cmd, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_StartDownload(CSwallow* _pSwallow, int _lLogonId, CString _cstrRemoteFile, CString _cstrLocalFile, int _iFlag)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lLogonId);
	VARIANT var2 = getstovar(_cstrRemoteFile);
	VARIANT var3 = getstovar(_cstrLocalFile);
	VARIANT var4 = getitovar(_iFlag);
	CString szRet = _pSwallow->Commander(Store_DLStart_Cmd, var1, var2, var3, var4, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	int iDLId = _ttoi(szResult[1]);
	return iDLId;
}

int Swallow_StopDownload(CSwallow* _pSwallow, int _lDLId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lDLId);
	CString szRet = _pSwallow->Commander(Store_DLStop_Cmd, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_GetDownloadPos(CSwallow* _pSwallow, int _lDLId, OUT int &_iPos, OUT int &_iDLSize)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lDLId);
	CString szRet = _pSwallow->Commander(Store_DLProgress_Get, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	_iPos = _ttoi(szResult[1]);
	_iDLSize = _ttoi(szResult[2]);
	return 0;
}


int Swallow_SetEZoomEnable(CSwallow* _pSwallow, long _lobsId, int _iEnable)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var2 = getitovar(_iEnable);
	CString szRet = _pSwallow->Commander(Obs_EZoomEnable_Set, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_GetEZoomEnable(CSwallow* _pSwallow, long _lobsId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	CString szRet = _pSwallow->Commander(Obs_EZoomEnable_Get, var1, var, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return _ttoi(szResult[1]);
}

int Swallow_SetLocalTime(CSwallow* _pSwallow, int _iLogonId)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);

	SYSTEMTIME systime = {0};
	GetLocalTime(&systime);

	VARIANT varLogId = getitovar(_iLogonId);
	VARIANT varY = getitovar(systime.wYear);
	VARIANT varM = getitovar(systime.wMonth);
	VARIANT varD = getitovar(systime.wDay);
	VARIANT varH = getitovar(systime.wHour);
	VARIANT varMi = getitovar(systime.wMinute);
	VARIANT varS = getitovar(systime.wSecond);
	VARIANT varZ = getitovar(0);
	
	CString szRet = _pSwallow->Commander(Sys_LocalTime_Set, varLogId, varY, varM, varD, varH, varMi, varS, varZ, varZ);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_StartPicStream(CSwallow* _pSwallow, int _iLogonId, int _iChannelNo)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_iLogonId);
	VARIANT var2 = getitovar(_iChannelNo);
	CString szRet = _pSwallow->Commander(Alarm_StartPicStream, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_StopPicStream(CSwallow* _pSwallow, int _iLogonId, int _iChannelNo)
{
	CHECK_EQUAL_RETURN(_pSwallow, NULL, -1);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_iLogonId);
	VARIANT var2 = getitovar(_iChannelNo);
	CString szRet = _pSwallow->Commander(Alarm_StopPicStream, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	return 0;
}

int Swallow_GetPicStream(CSwallow* _pSwallow, int _iLogonId, int _iChannelNo, CString &_cstrPicInfo)
{
	if (NULL == _pSwallow)
	{
		return -1;
	}

	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(_iLogonId);
	VARIANT var2 = getitovar(_iChannelNo);
	CString szRet = _pSwallow->Commander(Alarm_GetPicStreamInfo, var1, var2, var, var, var, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (0 != CheckRetValue(szRet, szResult))
	{
		return -1;
	}
	_cstrPicInfo = szResult[1];
	
	return 0;
}
